Package edu.wisc.game.sql

## Class EpisodeMemory.BucketVarMap2

- java.lang.Object
- - java.util.AbstractMap<K,​V>
  - - java.util.HashMap<String,​HashSet<T>>
    - - edu.wisc.game.parser.Expression.MapTo<Object>
      - - edu.wisc.game.parser.Expression.VarMap2
        - - edu.wisc.game.sql.EpisodeMemory.BucketVarMap2

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Map<String,​HashSet<Object>>`
  Enclosing class:
    EpisodeMemory

      public class EpisodeMemory.BucketVarMap2
      extends Expression.VarMap2

  Variables needed for GS5 expressions. p, ps, pc -- legacy bucket numbers p.propName -- GS3 property-based bucket numbers this -- the game piece which the player tries to move now last -- the most recently successfully moved piece q.propName -- the most recently successfully moved piece whose property with the specified name shared its value with the current piece. (E.g. the most recent same-color or same-shape piece) q.bucket -- the piece most recently moved into the same bucket as being tried now
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `AbstractMap.SimpleEntry<K extends Object,​V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,​V extends Object>`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K extends Object,​V extends Object>`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BucketVarMap2​(Piece p, int bucketNo)` |

  - ### Method Summary

    - ### Methods inherited from class edu.wisc.game.parser.Expression.VarMap2

      `addValue`

    - ### Methods inherited from class edu.wisc.game.parser.Expression.MapTo

      `pu, pu, putSet, toString`

    - ### Methods inherited from class java.util.HashMap

      `clear, clone, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, forEach, get, getOrDefault, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

    - ### Methods inherited from class java.util.AbstractMap

      `equals, hashCode`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `equals, hashCode`

- - ### Constructor Detail

    - #### BucketVarMap2

          public BucketVarMap2​(Piece p,
                               int bucketNo)